Index: trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solmat.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solmat.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solmat.F90	(revision 2528)
@@ -15,4 +15,5 @@
    !!             3.2  ! 2009-06  (S. Masson)  distributed restart using iom
    !!              -   ! 2009-07  (R. Benshila)  suppression of rigid-lid option
+   !!             3.3  ! 2010-09  (D. Storkey) update for BDY module.
    !!----------------------------------------------------------------------
 
@@ -26,4 +27,5 @@
    USE phycst          ! physical constants
    USE obc_oce         ! ocean open boundary conditions
+   USE bdy_oce         ! unstructured open boundary conditions
    USE lbclnk          ! lateral boudary conditions
    USE lib_mpp         ! distributed memory computing
@@ -36,7 +38,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -80,5 +82,5 @@
       ENDIF
 
-#if defined key_dynspg_flt 
+#if defined key_dynspg_flt && ! defined key_bdy
 #   if ! defined key_obc
 
@@ -158,4 +160,38 @@
     ENDIF
 #   endif
+
+#  elif defined key_dynspg_flt && defined key_bdy 
+
+      !   defined gcdmat in the case of unstructured open boundaries
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            zcoef = z2dt * z2dt * grav * bmask(ji,jj)
+
+            !  south coefficient
+            zcoefs = -zcoef * hv(ji,jj-1) * e1v(ji,jj-1)/e2v(ji,jj-1)
+            zcoefs = zcoefs * bdyvmask(ji,jj-1)
+            gcp(ji,jj,1) = zcoefs
+
+            !  west coefficient
+            zcoefw = -zcoef * hu(ji-1,jj) * e2u(ji-1,jj)/e1u(ji-1,jj)
+            zcoefw = zcoefw * bdyumask(ji-1,jj)
+            gcp(ji,jj,2) = zcoefw
+
+            !  east coefficient
+            zcoefe = -zcoef * hu(ji,jj) * e2u(ji,jj)/e1u(ji,jj)
+            zcoefe = zcoefe * bdyumask(ji,jj)
+            gcp(ji,jj,3) = zcoefe
+
+            !  north coefficient
+            zcoefn = -zcoef * hv(ji,jj) * e1v(ji,jj)/e2v(ji,jj)
+            zcoefn = zcoefn * bdyvmask(ji,jj)
+            gcp(ji,jj,4) = zcoefn
+
+            ! diagonal coefficient
+            gcdmat(ji,jj) = e1t(ji,jj)*e2t(ji,jj)*bmask(ji,jj) &
+                            - zcoefs -zcoefw -zcoefe -zcoefn
+         END DO
+      END DO
+
 #endif
 
@@ -297,5 +333,5 @@
          SELECT CASE ( cd_type )
          ! 
-         CASE ( 'T', 'S', 'U', 'W' )
+         CASE ( 'T' , 'U', 'W' )
             DO jk = 1, 4
                DO ji = 1-jpr2di, nlci+jpr2di
@@ -311,5 +347,5 @@
             END DO
             !
-         CASE ( 'F' ,'G' , 'I', 'V' )
+         CASE ( 'F' , 'I', 'V' )
             DO jk =1, 4
                DO ji = 1-jpr2di, nlci+jpr2di
@@ -325,5 +361,5 @@
          SELECT CASE (cd_type )
          !
-         CASE ( 'T'  ,'S', 'U', 'W')
+         CASE ( 'T' , 'U', 'W')
             DO jk =1, 4
                DO ji = 1-jpr2di, nlci+jpr2di
@@ -332,5 +368,5 @@
             END DO
             !
-         CASE ( 'F' ,'G' , 'I', 'V' )
+         CASE ( 'F' , 'I', 'V' )
             DO jk =1, 4
                DO ji = 1-jpr2di, nlci+jpr2di
Index: trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solpcg.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solpcg.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solpcg.F90	(revision 2528)
@@ -14,4 +14,5 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE in_out_manager  ! I/O manager
+   USE lib_fortran
 
    IMPLICIT NONE
@@ -23,7 +24,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
@@ -95,4 +96,6 @@
       ! Initialization of the algorithm with standard PCG
       ! -------------------------------------------------
+      zgcr = 0.e0 
+      gcr  = 0.e0 
 
       CALL lbc_lnk( gcx, c_solver_pt, 1. )   ! lateral boundary condition
@@ -100,5 +103,4 @@
       ! gcr   = gcb-a.gcx
       ! gcdes = gcr
-
       DO jj = 2, jpjm1
          DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -114,6 +116,5 @@
 
       ! rnorme = (gcr,gcr)
-      rnorme = SUM(  gcr(:,:) * gcdmat(:,:) * gcr(:,:)  )
-      IF( lk_mpp )   CALL mpp_sum( rnorme )   ! sum over the global domain
+      rnorme = glob_sum(  gcr(:,:) * gcdmat(:,:) * gcr(:,:)  )
 
       CALL lbc_lnk( gcdes, c_solver_pt, 1. )   ! lateral boundary condition
@@ -129,6 +130,5 @@
 
       ! alph = (gcr,gcr)/(gcdes,gccd)
-      radd = SUM(  gcdes(:,:) * gcdmat(:,:) * gccd(:,:)  )
-      IF( lk_mpp )   CALL mpp_sum( radd )   ! sum over the global domain
+      radd = glob_sum(  gcdes(:,:) * gcdmat(:,:) * gccd(:,:)  )
       alph = rnorme /radd
 
@@ -162,13 +162,12 @@
          ! rnorme = (gcr,gcr)
          rr = rnorme
-         zsum(1) = SUM(  gcr(:,:) * gcdmat(:,:) * gcr(:,:)  )
 
          ! zgcad = (zgcr,gcr) 
-         zsum(2) = SUM( gcr(2:jpim1,2:jpjm1) * gcdmat(2:jpim1,2:jpjm1) * zgcr(2:jpim1,2:jpjm1) )
-
-         IF( lk_mpp )   CALL mpp_sum( zsum, 2 )   ! sum over the global domain
+         zsum(1) = glob_sum(gcr(:,:) * gcdmat(:,:) * gcr(:,:))
+         zsum(2) = glob_sum(gcr(:,:) * gcdmat(:,:) * zgcr(:,:) * bmask(:,:))
+
+         !!RB we should gather the 2 glob_sum
          rnorme = zsum(1)  
          zgcad  = zsum(2)
-
          ! test of convergence
          IF( rnorme < epsr .OR. jn == nn_nmax ) THEN
Index: trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solsor.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solsor.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solsor.F90	(revision 2528)
@@ -22,4 +22,5 @@
    USE lib_mpp         ! distributed memory computing
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE lib_fortran
 
    IMPLICIT NONE
@@ -29,7 +30,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -64,4 +65,5 @@
       INTEGER  ::   ijmppodd, ijmppeven, ijpr2d
       REAL(wp) ::   ztmp, zres, zres2
+      REAL(wp), DIMENSION(jpi,jpj) ::ztab
       !!----------------------------------------------------------------------
       
@@ -131,6 +133,7 @@
                ENDIF
             CASE ( 1 )                 ! relative precision
-               rnorme = SUM( gcr(2:nlci-1,2:nlcj-1) )
-               IF( lk_mpp )   CALL mpp_sum( rnorme )   ! sum over the global domain
+               ztab = 0.
+               ztab(:,:) = gcr(2:nlci-1,2:nlcj-1)
+               rnorme = glob_sum( ztab)    ! sum over the global domain
                ! test of convergence
                IF( rnorme < epsr .OR. jn == nn_nmax ) THEN
Index: trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solver.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solver.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SOL/solver.F90	(revision 2528)
@@ -31,7 +31,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 9.0 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -102,17 +102,8 @@
       END SELECT
       !
-      IF( nbit_cmp == 1 ) THEN            ! reproductibility test SOR required
-         IF( nn_solv /= 2 ) THEN
-            CALL ctl_stop( ' Reproductibility tests (nbit_cmp=1) require the SOR solver: nn_solv = 2' )
-         ELSE IF( MAX( jpr2di, jpr2dj ) > 0 ) THEN
-            CALL ctl_stop( ' Reproductibility tests (nbit_cmp=1) require jpr2di = jpr2dj = 0' )
-         END IF 
-      END IF
 
       !                             !* Grid-point at which the solver is applied
 !!gm  c_solver_pt should be removed: nomore bsf, only T-point is used
-      IF( lk_mpp ) THEN   ;    c_solver_pt = 'S'   ! S=T with special staff ??? which one?
-      ELSE                ;    c_solver_pt = 'T'
-      ENDIF
+      c_solver_pt = 'T'                   ! always T-point (ssh solver only, not anymore bsf)
 
       CALL sol_mat( kt )            !* Construction of the elliptic system matrix
